<?php
//
// Copyright 2015 - 2016, Julian Catchen <jcatchen@illinois.edu>
//
// This file is part of Chromonomer.
//
// Chromonomer is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Chromonomer is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Chromonomer.  If not, see <http://www.gnu.org/licenses/>.
//
include("header.php");

$ver  = isset($_GET['v'])   ? $_GET['v']   : "";
$log  = isset($_GET['log']) ? $_GET['log'] : 0;

write_header("Log: " . $log);

echo <<< EOQ

<h1 class="lg">Log $log</h1>

<pre>

EOQ;

$segment_colors      = array();
$segment_color_index = 0;

$lines = file("$file_path/$ver/$log" . ".log");

foreach ($lines as $line) {
    $line = preg_replace('/(\[split failure\])/', '<span class="splitfail">$1</span>', $line);
    $line = preg_replace('/(Segment \d+ end)/',   '<span class="scafann">$1</span>',   $line);
    $line = preg_replace('/(Segment \d+ begin)/', '<span class="scafann">$1</span>',   $line);

    if (preg_match('/^Creating scaffold \'(.+)\' with \d+ elements \[\d+ \-> \d+\]\./', $line, $matches)) {
        $path = "$file_path/$ver/" . $matches[1] . ".log";
        if (file_exists($path)) {
            $line = preg_replace("/$matches[1]/", "<a href=\"view_log.php?v=$ver&log=$matches[1]\" class=\"newscaf\">$matches[1]</a>",   $line);
        }
    }

    if (preg_match('/bp => segment\s+(\d+) \[/', $line, $matches)) {
        if (!isset($segment_colors[$matches[1]])) {
            $segment_colors[$matches[1]] = $color_scheme[$segment_color_index % count($color_scheme)];
            $segment_color_index++;
        }
        $color = $segment_colors[$matches[1]];
        $line = "<span style=\"color: $color;\">" . rtrim($line) . "</span>\n";
    }
    print $line;
}

print "</pre>";

write_footer();
?>